/* ************************************************************************

   Copyright: Weizmann Institute of Science

   License: GPL

   Authors: Evgeny Stambulchik

************************************************************************ */

/* ************************************************************************

#asset(pf/image/*.png)
#asset(pf/html/*.html)

************************************************************************ */

// global
var plasma_entities;

function changeN_e(ev)
{
    var e = ev.getTarget();
    var N_e = e.getNumValue();
    
    if (isFinite(N_e) && this.plasma.e.setN(N_e)) {
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_e(ev)
{
    var e = ev.getTarget();
    var T_e = e.getNumValue();
    
    if (isFinite(T_e)) {
        this.plasma.e.setT(T_e);
        if (!this.gui_locked) {
            this.plasma.i.setT(T_e);
            this.plasma.r.setT(T_e);
            this.updateGUI();
        }
    }
}

function changeZ_i(ev)
{
    var e = ev.getTarget();
    var Z_i = parseInt(e.getValue());
    
    if (isFinite(Z_i)) {
        this.plasma.i.setQ(Z_i);
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_i(ev)
{
    var e = ev.getTarget();
    var T_i = e.getNumValue();
    
    if (isFinite(T_i)) {
        this.plasma.i.setT(T_i);
        if (!this.gui_locked) {
            this.plasma.r.setT(T_i);
            this.updateGUI();
        }
    }
}

function changeZ_r(ev)
{
    var e = ev.getTarget();
    var Z_r = parseInt(e.getValue());
    
    if (isFinite(Z_r)) {
        this.plasma.r.setQ(Z_r);
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeP_r(ev)
{
    var e = ev.getTarget();
    var P_r = parseFloat(e.getValue())/100.0;
    
    if (isFinite(P_r)) {
        this.plasma.P_r = P_r;
        this.updatePlasmaParameters();
        this.updateGUI();
    }
}

function changeT_r(ev)
{
    var e = ev.getTarget();
    var T_r = e.getNumValue();
    
    if (isFinite(T_r)) {
        this.plasma.r.setT(T_r);
        this.updateGUI();
    }
}

function changeM_i(ev)
{
    var e = ev.getTarget();
    var M_i = e.getNumValue();
    
    if (isFinite(M_i)) {
        this.plasma.i.setM(M_i);
        this.updateGUI();
    }
}

function changeM_r(ev)
{
    var e = ev.getTarget();
    var M_r = e.getNumValue();
    
    if (isFinite(M_r)) {
        this.plasma.r.setM(M_r);
        this.updateGUI();
    }
}

function changeN_u(ev)
{
    var e = ev.getTarget();
    var n_u = parseInt(e.getValue());
    
    this.gui_n_l.setMaximum(n_u - 1);
    
    this.plasma.r.setN_u(n_u);
    this.updateGUI();
}

function changeN_l(ev)
{
    var e = ev.getTarget();
    var n_l = parseInt(e.getValue());
    
    this.gui_n_u.setMinimum(n_l + 1);
    
    this.plasma.r.setN_l(n_l);
    this.updateGUI();
}

function changeB(ev)
{
    var e = ev.getTarget();
    var v = e.getNumValue();
    
    if (isFinite(v)) {
        this.plasma.B = v;
        this.updateGUI();
    }
}

function viewMenuCB(ev)
{
    var explorer_is_seen;
    
    if (this.entity_tree.isSeeable()) {
        explorer_is_seen = true;
    } else {
        explorer_is_seen = false;
    }
    
    this.showSectionsButton.setEnabled(explorer_is_seen);
    this.showSpeciesButton.setEnabled(explorer_is_seen);
    this.redrawButton.setEnabled(this.canvas.isSeeable());

    if (this.prefs.autoLoadWiki) {
        this.loadWikiButton.setEnabled(false);
    } else {
        var tree = this.entity_tree;
        var leaf = getSingleTreeSelectedItem(tree);
        if (leaf && leaf.classname == "qx.ui.tree.TreeFile" && explorer_is_seen) {
            this.loadWikiButton.setEnabled(true);
        } else {
            this.loadWikiButton.setEnabled(false);
        }
    }
}

function editMenuCB(ev)
{
    var explorer_is_seen;
    
    if (this.entity_tree.isSeeable()) {
        explorer_is_seen = true;
    } else {
        explorer_is_seen = false;
    }

    var tree = this.entity_tree;
    var leaf = getSingleTreeSelectedItem(tree);

    if (leaf && leaf.classname == "qx.ui.tree.TreeFile" && explorer_is_seen) {
        if (this.isFavorite(leaf)) {
            this.editMenuButtonAddToFav.setEnabled(false);
            this.editMenuButtonRemFromFav.setEnabled(true);
        } else {
            this.editMenuButtonAddToFav.setEnabled(true);
            this.editMenuButtonRemFromFav.setEnabled(false);
        }
    } else {
        this.editMenuButtonAddToFav.setEnabled(false);
        this.editMenuButtonRemFromFav.setEnabled(false);
    }
}

function getSingleTreeSelectedItem(tree)
{
    var sels = tree.getSelection();
    if (sels && sels.length == 1) {
        return sels[0];
    } else {
        return null;
    }
}

function treeMenuCB(ev)
{
    if (ev.getButton() == "right") {
        var menu = this.treeMenu;

        if (menu.isSeeable()) {
            menu.hide();
        } else {
            var w = ev.getTarget();
            var leaf = null;
            if (w.classname == "qx.ui.tree.TreeFile") {
                leaf = w;
            } else
            if (w.getLayoutParent().classname == "qx.ui.tree.TreeFile") {
                leaf = w.getLayoutParent();
            }
            
            if (leaf) {
                if (this.isFavorite(leaf)) {
                    this.treeMenuButtonAddToFav.setEnabled(false);
                    this.treeMenuButtonRemFromFav.setEnabled(true);
                } else {
                    this.treeMenuButtonAddToFav.setEnabled(true);
                    this.treeMenuButtonRemFromFav.setEnabled(false);
                }
            } else {
                this.treeMenuButtonAddToFav.setEnabled(false);
                this.treeMenuButtonRemFromFav.setEnabled(false);
            }
            
            // position & show the menu
            menu.placeToMouse(ev);
            menu.show();
        };

        // ev.stopPropagation();
    }
}

function showFundamentalCB(ev)
{
    this.showFundamental = !this.showFundamental;
    this.rePopulateTree();
}

function showSpectroscopyCB(ev)
{
    this.showSpectroscopy = !this.showSpectroscopy;
    this.rePopulateTree();
}

function showWavesCB(ev)
{
    this.showWaves = !this.showWaves;
    this.rePopulateTree();
}

function showCollisionsCB(ev)
{
    this.showCollisions = !this.showCollisions;
    this.rePopulateTree();
}

function showRadiationCB(ev)
{
    this.showRadiation = !this.showRadiation;
    this.rePopulateTree();
}

function showElectronsCB(ev)
{
    this.showElectrons = !this.showElectrons;
    this.rePopulateTree();
}

function showIonsCB(ev)
{
    this.showIons = !this.showIons;
    this.rePopulateTree();
}

function showRadiatorsCB(ev)
{
    this.showRadiators = !this.showRadiators;
    this.rePopulateTree();
}

function addToFavCB(ev)
{
    var tree = this.entity_tree;
    var leaf = getSingleTreeSelectedItem(tree);

    if (!leaf) {
        return;
    }

    leaf.setTextColor(this.leafFavColor);

    // Add to the list of favorites
    var fav = new Object;
    fav.entity = leaf.getUserData("entity");
    fav.s1     = leaf.getUserData("s1");
    fav.s2     = leaf.getUserData("s2");
    fav.color  = this.nextColor();
    this.favorites.push(fav);
    
    // Switch the dimension selector ...
    this.gui_compare_dim.selectByValue(fav.entity.dimension);
    // ... and update the list of favorites
    this.updateFavoritesListView();
    this.updateLegendListView();
    
    this.saveFavorites();
}

function removeFromFavCB(ev)
{
    var tree = this.entity_tree;
    var leaf = getSingleTreeSelectedItem(tree);

    if (!leaf) {
        return;
    }
    leaf.setTextColor(this.leafColor);

    var entity = leaf.getUserData("entity");
    var s1     = leaf.getUserData("s1");
    var s2     = leaf.getUserData("s2");

    // Remove from the list of favorites
    for (var k = 0; k < this.favorites.length; k++) {
        var fav = this.favorites[k];
        if (fav.entity  == entity && fav.s1 == s1 && fav.s2 == s2) {
            this.favorites.splice(k, 1);
            break;
        }
    }

    // Switch the dimension selector ...
    this.gui_compare_dim.selectByValue(entity.dimension);
    // ... and update the list of favorites
    this.updateFavoritesListView();
    this.updateLegendListView();
    
    this.saveFavorites();
}

function clickTreeCB(ev)
{
    var tree = ev.getTarget();
    var e = getSingleTreeSelectedItem(tree);
    if (e) {
        var entity = e.getUserData("entity");
        
        if (entity) {
            this.gui_entity_units.update(entity.dimension,
                this.prefs.units[entity.dimension]);
        } else {
            this.gui_entity_units.update(null, null);
        }
        
        this.updateEntityValue();
    }
}

function changeUnitsCB(ev)
{
    this.updateEntityValue();
}

/**
 * The application
 */
qx.Class.define("pf.Application",
{
    extend : qx.application.Standalone,

    /*
    *****************************************************************************
       MEMBERS
    *****************************************************************************
    */

    members :
    {
        showFundamental  : true,
        showSpectroscopy : true,
        showWaves        : true,
        showCollisions   : true,
        showRadiation    : true,

        showElectrons  : true,
        showIons       : true,
        showRadiators  : true,
        
        leafColor      : "black",
        leafFavColor   : "red",
        
        plasma : null,

        updatePlasmaParameters : function()
        {
            return this.plasma.updateParameters();
        },
        
        updateGUI : function()
        {
            if (this.gui_locked) {
                return;
            }
            
            this.gui_locked = true;
            
            // Make sure GUI does not remain locked forever...
            try {
                if (this.prefs.currentConfigName) {
                    this.gui_configName.setLabel(this.prefs.currentConfigName);
                }

                this.gui_N_e.setNumValue(this.plasma.e.getN());
                this.gui_T_e.setNumValue(this.plasma.e.getT());

                this.gui_N_i.setNumValue(this.plasma.i.getN());
                this.gui_T_i.setNumValue(this.plasma.i.getT());
                this.gui_Z_i.setValue(this.plasma.i.getQ());
                this.gui_M_i.setNumValue(this.plasma.i.getM());

                this.gui_P_r.setValue(100*this.plasma.P_r);

                this.gui_N_r.setNumValue(this.plasma.r.getN());
                this.gui_T_r.setNumValue(this.plasma.r.getT());
                this.gui_Z_r.setValue(this.plasma.r.getQ());
                this.gui_Zcore.setValue((this.plasma.r.getQ() + 1) + '');
                this.gui_M_r.setNumValue(this.plasma.r.getM());

                this.gui_B.setNumValue(this.plasma.B);

                // Make sure n_u > n_l holds during update
                if (this.gui_n_l.getValue() >= this.plasma.r.getN_u()) {
                    this.gui_n_l.setValue(this.plasma.r.getN_l());
                    this.gui_n_u.setValue(this.plasma.r.getN_u());
                } else {
                    this.gui_n_u.setValue(this.plasma.r.getN_u());
                    this.gui_n_l.setValue(this.plasma.r.getN_l());
                }

                // Update the currently selected entity
                this.updateEntityValue();

                // Update the list of favorites
                this.updateFavoritesListView();
                this.updateLegendListView();
            } catch (err) {
                this.error(err);
            }
            
            this.gui_locked = false;
        },
        

        getSpeciesName : function(species) {
            var name;
            
            switch (species.id) {
            case "e":
                name = "electrons";
                break;
            case "i":
                name = "ions";
                break;
            case "r":
                name = "radiators";
                break;
            default:
                name = null;
                break;
            }
            
            return name;
        },
        
        getEntityFullName : function(entity, s1, s2)
        {
            var name = entity.name;
            switch (entity.nspecies) { 
            case 2:
                name += " (" + this.getSpeciesName(s1) + "/" +
                               this.getSpeciesName(s2) + ")";
                break;
            case 1:
                var prepos = entity.prepos;
                if (!prepos) {
                    prepos = "of";
                }
                name += " " + prepos + " " + this.getSpeciesName(s1);
                break;
            default:
                break;
            }
            
            return name;
        },
        
        evaluateEntityValue : function(entity, s1, s2)
        {
            var formula;
            switch (entity.nspecies) {
            case 1:
                var s1_str = "this.plasma." + s1.id;
                formula = entity.formula.replace(/\%s1/g, s1_str);
                break;
            case 2:
                var s1_str = "this.plasma." + s1.id;
                var s2_str = "this.plasma." + s2.id;
                formula = entity.formula.replace(/\%s1/g, s1_str);
                formula = formula.replace(/\%s2/g, s2_str);
                break;
            default:
                formula = entity.formula;
                break;
            }
            var v = eval(formula);
            
            return v;
        },
        
        updateEntityValue : function()
        {
            var tree = this.entity_tree;
            var leaf = getSingleTreeSelectedItem(tree);
            
            if (!leaf) {
                return;
            }
            
            var entity = leaf.getUserData("entity");
            var s1     = leaf.getUserData("s1");
            var s2     = leaf.getUserData("s2");
            
            var name, section, value;
            if (entity) {
                var v     = this.evaluateEntityValue(entity, s1, s2);
                var scale = this.gui_entity_units.getSelectedValue();
                
                name    = this.getEntityFullName(entity, s1, s2);
                section = entity.section;
                value   = v*scale
            } else {
                name    = null;
                section = null;
                value   = 0;
            }
            
            this.gui_entity_name.setValue(name);

            this.gui_entity_section.setValue(section);

            if (isFinite(value)) {
                this.gui_entity_value.setNumValue(value);
            } else {
                this.gui_entity_value.setValue("");
            }
            
            if (this.prefs.autoLoadWiki) {
                this.showWikiPage(entity);
            } else {
                this.showWikiPage(null);
            }
        },

        isFavorite : function(leaf)
        {
            var entity = leaf.getUserData("entity");
            var s1     = leaf.getUserData("s1");
            var s2     = leaf.getUserData("s2");

            for (var k = 0; k < this.favorites.length; k++) {
                var fav = this.favorites[k];
                if (fav.entity  == entity && fav.s1 == s1 && fav.s2 == s2) {
                    return true;
                    break;
                }
            }
            
            return false;
        },
        
        addEntityLeaf : function(entity, s1, s2)
        {
            var icon;
            
            if (s1 && s2) {
                icon = "pf/image/" + s1.id + s2.id + "_small.png";
            } else
            if (s1) {
                icon = "pf/image/" + s1.id + "_small.png";
            } else {
                icon = "pf/image/all_small.png";
            }
            
            var leaf = new qx.ui.tree.TreeFile(entity.name);
            leaf.setIcon(icon);
            leaf.addListener("contextmenu", treeMenuCB, this);

            leaf.setUserData("entity", entity);
            leaf.setUserData("s1", s1);
            leaf.setUserData("s2", s2);

            if (this.isFavorite(leaf)) {
                leaf.setTextColor(this.leafFavColor);
            } else {
                leaf.setTextColor(this.leafColor);
            }
            
            return leaf;
        },

        populateTree : function()
        {
            var n = plasma_entities.length;
            var sa = new Array;
            if (this.showElectrons) {
                sa.push(this.plasma.e)
            }
            if (this.showIons) {
                sa.push(this.plasma.i)
            }
            if (this.showRadiators) {
                sa.push(this.plasma.r)
            }
            
            for (var i = 0; i < n; i++) {
                var entity = plasma_entities[i];
                
                if (entity.section == "fundamental" &&
                    this.showFundamental != true) {
                    continue;
                }
                if (entity.section == "spectroscopy" &&
                    this.showSpectroscopy != true) {
                    continue;
                }
                if (entity.section == "waves" &&
                    this.showWaves != true) {
                    continue;
                }
                if (entity.section == "collisions" &&
                    this.showCollisions != true) {
                    continue;
                }
                if (entity.section == "radiation" &&
                    this.showRadiation != true) {
                    continue;
                }
                
                var folder;
                switch (entity.dimension) {
                case "frequency":
                    folder = this.gui_folder_freq;
                    break;
                case "length":
                    folder = this.gui_folder_length;
                    break;
                case "velocity":
                    folder = this.gui_folder_vel;
                    break;
                case "energy":
                    folder = this.gui_folder_energy;
                    break;
                case "mass_density":
                    folder = this.gui_folder_mass_density;
                    break;
                case "pressure":
                    folder = this.gui_folder_pressure;
                    break;
                case "area":
                    folder = this.gui_folder_area;
                    break;
                case "power_density":
                    folder = this.gui_folder_power_density;
                    break;
                case "spectral_power_density":
                    folder = this.gui_folder_spectral_power_density;
                    break;
                case "efield":
                    folder = this.gui_folder_efield;
                    break;
                case "none":
                    folder = this.gui_folder_none;
                    break;
                default:
                    continue;
                    break;
                }
                
                var leaf;
                
                switch (entity.nspecies) {
                case 1:
                    for (var j = 0; j < sa.length; j++) {
                        var s = sa[j];
                        leaf = this.addEntityLeaf(entity, s, null);
                        folder.add(leaf);
                    }
                    break;
                case 2:
                    for (var j = 0; j < sa.length; j++) {
                        var s1 = sa[j];
                        for (var k = j; k < sa.length; k++) {
                            var s2 = sa[k];
                            leaf = this.addEntityLeaf(entity, s1, s2);
                            folder.add(leaf);
                        }
                    }
                    break;
                default:
                    leaf = this.addEntityLeaf(entity, null, null);
                    folder.add(leaf);
                    break;
                }
            }
        }, 

        cleanTree : function()
        {
            this.gui_folder_freq.removeAll();
            
            this.gui_folder_length.removeAll();
            
            this.gui_folder_vel.removeAll();
            
            this.gui_folder_none.removeAll();
            
            this.gui_folder_energy.removeAll();
            
            this.gui_folder_mass_density.removeAll();

            this.gui_folder_pressure.removeAll();
            
            this.gui_folder_area.removeAll();
            
            this.gui_folder_power_density.removeAll();

            this.gui_folder_spectral_power_density.removeAll();
            
            this.gui_folder_efield.removeAll();
        },

        rePopulateTree : function()
        {
            this.cleanTree();
            
            this.populateTree();
        },


        updateFavoritesListView : function()
        {
            var lv = this.favoritesListView;
            var tm = lv.getTableModel();
            
            var dimension = this.gui_compare_dim.getSelectedValue();
            
            var scale = this.gui_compare_units.getSelectedValue();
            
            var rowData = new Array();
            
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var s1 = fav.s1;
                var s2 = fav.s2;

                var icon;
                if (s1 && s2) {
                    icon = "pf/image/" + s1.id + s2.id + "_small.png";
                } else
                if (s1) {
                    icon = "pf/image/" + s1.id + "_small.png";
                } else {
                    icon = "pf/image/all_small.png";
                }
                var name = this.getEntityFullName(entity, s1, s2);
                var value = scale*this.evaluateEntityValue(entity, s1, s2);

                rowData.push([icon, name, entity.section,
                    pf.util.Format.numPrint(value)]);
            }
            
            tm.setData(rowData, false);
            var sidx = tm.getSortColumnIndex();
            tm.sortByColumn(sidx, tm.isSortAscending());
            
            lv.updateContent();
            // lv.updateSort();
            // lv.update();
        },

        updateLegendListView : function()
        {
            var lv = this.legendListView;
            var tm = lv.getTableModel();

            var rowData = new Array();
            
            var dimension = this.gui_compare_dim.getSelectedValue();
            
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var s1    = fav.s1;
                var s2    = fav.s2;

                var name  = this.getEntityFullName(entity, s1, s2);
                var color = fav.color;

                rowData.push({"color": color, "name": name, "favorite": fav});
            }
            
            tm.setDataAsMapArray(rowData);
            // lv.updateContent();
        },


        renderTabPage : function(label, icon, checked)
        {
            var page_id;
            
            page_id = new qx.ui.tabview.Page(label, icon);
            this.tabview.add(page_id, {height: "100%"});

            if (checked) {
                this.tabview.setSelection(page_id);
            }
            
            return page_id;
        },

        renderParametersTab : function()
        {
            var fr, gl, rc, rc1, rc2;
            
            var page_id = this.renderTabPage("Parameters",
                "pf/image/tab-parameters.png", true);
            page_id.setLayout(new qx.ui.layout.VBox(10));

            fr = new qx.ui.groupbox.GroupBox("Configuration name",
                "pf/image/info.png");
            fr.setLayout(new qx.ui.layout.VBox());

            this.gui_configName =
                new qx.ui.basic.Atom(this.prefs.currentConfigName);
            this.gui_configName.setRich(true)
            fr.add(this.gui_configName);
            page_id.add(fr);
            

            rc = new qx.ui.container.Composite(new qx.ui.layout.HBox(10));
            page_id.add(rc);
            
            rc1 = new qx.ui.container.Composite(new qx.ui.layout.VBox(10));
            rc.add(rc1, {flex : 1});
            
            rc2 = new qx.ui.container.Composite(new qx.ui.layout.VBox(27));
            rc.add(rc2, {flex : 1});
            
            
            fr = new qx.ui.groupbox.GroupBox("Electrons",
                "pf/image/e_small.png");
            fr.setLayout(new qx.ui.layout.VBox());

            rc1.add(fr);

            var layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 80);
            layout.setColumnFlex(1, 1);
            gl = new qx.ui.container.Composite(layout);

            fr.add(gl);

            var l, e, au_fn, au_fT;
            
            au_fn = pf.base.Bohr.n0;
            au_fT = pf.base.Bohr.E0;

            // N_e
            l = new qx.ui.basic.Label("N<sub>e</sub> (cm<sup>-3</sup>):");
            l.setRich(true);
            gl.add(l, {row: 0, column: 0});
            e = new pf.ui.TextField(this.plasma.e.getN(), au_fn);
            gl.add(e, {row: 0, column: 1});
            e.addListener("changeValue", changeN_e, this);
            this.gui_N_e = e;

            // T_e
            l = new qx.ui.basic.Label("T<sub>e</sub> (eV):");
            l.setRich(true);
            gl.add(l, {row: 1, column: 0});
            e = new pf.ui.TextField(this.plasma.e.getT(), au_fT);
            gl.add(e, {row: 1, column: 1});
            e.addListener("changeValue", changeT_e, this);
            this.gui_T_e = e;
            
            fr = new qx.ui.groupbox.GroupBox("Ions",
                "pf/image/i_small.png");
            fr.setLayout(new qx.ui.layout.VBox());

            rc1.add(fr);

            layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 80);
            layout.setColumnFlex(1, 1);
            gl = new qx.ui.container.Composite(layout);

            fr.add(gl);

            // Z_i
            l = new qx.ui.basic.Label("Z<sub>i</sub>:");
            l.setRich(true);
            gl.add(l, {row: 0, column: 0});
            e = new qx.ui.form.Spinner(1, this.plasma.i.getQ(), 100);
            gl.add(e, {row: 0, column: 1});
            e.addListener("changeValue", changeZ_i, this);
            this.gui_Z_i = e;
            
            // M_i
            l = new qx.ui.basic.Label("M<sub>i</sub>:");
            l.setRich(true);
            gl.add(l, {row: 1, column: 0});
            e = new pf.ui.TextField(this.plasma.i.getM(), 1/pf.base.Bohr.m_p);
            gl.add(e, {row: 1, column: 1});
            e.addListener("changeValue", changeM_i, this);
            this.gui_M_i = e;
            
            // T_i
            l = new qx.ui.basic.Label("T<sub>i</sub> (eV):");
            l.setRich(true);
            gl.add(l, {row: 2, column: 0});
            e = new pf.ui.TextField(this.plasma.i.getT(), au_fT);
            gl.add(e, {row: 2, column: 1});
            e.addListener("changeValue", changeT_i, this);
            this.gui_T_i = e;

            // N_i
            l = new qx.ui.basic.Label("N<sub>i</sub> (cm<sup>-3</sup>):");
            l.setRich(true);
            gl.add(l, {row: 3, column: 0});
            e = new pf.ui.TextField(this.plasma.i.getN(), au_fn);
            gl.add(e, {row: 3, column: 1});
            e.setReadOnly(true);
            this.gui_N_i = e;
            
            fr = new qx.ui.groupbox.GroupBox("Radiators",
                "pf/image/r_small.png");
            fr.setLayout(new qx.ui.layout.VBox());

            rc2.add(fr);

            layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 80);
            layout.setColumnFlex(1, 1);
            gl = new qx.ui.container.Composite(layout);

            fr.add(gl);

            // Z_r
            l = new qx.ui.basic.Label("Z<sub>r</sub>:");
            l.setRich(true);
            gl.add(l, {row: 0, column: 0});
            e = new qx.ui.form.Spinner(0, this.plasma.r.getQ(), 100);
            gl.add(e, {row: 0, column: 1});
            e.addListener("changeValue", changeZ_r, this);
            this.gui_Z_r = e;

            // M_r
            l = new qx.ui.basic.Label("M<sub>r</sub>:");
            l.setRich(true);
            gl.add(l, {row: 1, column: 0});
            e = new pf.ui.TextField(this.plasma.r.getM(), 1/pf.base.Bohr.m_p);
            gl.add(e, {row: 1, column: 1});
            e.addListener("changeValue", changeM_r, this);
            this.gui_M_r = e;

            // T_r
            l = new qx.ui.basic.Label("T<sub>r</sub> (eV):");
            l.setRich(true);
            gl.add(l, {row: 2, column: 0});
            e = new pf.ui.TextField(this.plasma.r.getT(), au_fT);
            gl.add(e, {row: 2, column: 1});
            e.addListener("changeValue", changeT_r, this);
            this.gui_T_r = e;

            // P_r
            l = new qx.ui.basic.Label("P<sub>r</sub> (%):");
            l.setRich(true);
            gl.add(l, {row: 3, column: 0});
            e = new qx.ui.form.Spinner(0, 100*this.plasma.P_r, 100);
            var nf = new qx.util.format.NumberFormat();
            nf.setMaximumFractionDigits(3);
            e.setNumberFormat(nf);
            gl.add(e, {row: 3, column: 1});
            e.addListener("changeValue", changeP_r, this);
            this.gui_P_r = e;

            // N_r
            l = new qx.ui.basic.Label("N<sub>r</sub> (cm<sup>-3</sup>):");
            l.setRich(true);
            gl.add(l, {row: 4, column: 0});
            e = new pf.ui.TextField(this.plasma.r.getN(), au_fn);
            e.setReadOnly(true);
            gl.add(e, {row: 4, column: 1});
            this.gui_N_r = e;


            fr = new qx.ui.groupbox.GroupBox("Fields",
                "pf/image/field_small.png");
            fr.setLayout(new qx.ui.layout.VBox());

            rc1.add(fr);

            layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 80);
            layout.setColumnFlex(1, 1);
            gl = new qx.ui.container.Composite(layout);

            fr.add(gl);


            l = new qx.ui.basic.Label("B (T):");
            l.setRich(true);
            gl.add(l, {row: 0, column: 0});
            e = new pf.ui.TextField(this.plasma.B, pf.base.Bohr.B0);
            gl.add(e, {row: 0, column: 1});
            e.addListener("changeValue", changeB, this);
            this.gui_B = e;

            // Atomic system frame
            fr = new qx.ui.groupbox.GroupBox("Atomic system",
                "pf/image/all_small.png");
            fr.setLayout(new qx.ui.layout.VBox());

            rc2.add(fr);

            layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 80);
            layout.setColumnFlex(1, 1);
            gl = new qx.ui.container.Composite(layout);

            fr.add(gl);

            l = new qx.ui.basic.Label("Z<sub>core</sub>:");
            l.setRich(true);
            gl.add(l, {row: 0, column: 0});
            e = new qx.ui.form.TextField((this.plasma.r.getQ() + 1) + '');
            e.setReadOnly(true);
            gl.add(e, {row: 0, column: 1});
            this.gui_Zcore = e;

            l = new qx.ui.basic.Label("n<sub>u</sub>:");
            l.setRich(true);
            gl.add(l, {row: 1, column: 0});
            e = new qx.ui.form.Spinner(this.plasma.r.getN_l() + 1,
                this.plasma.r.getN_u(), 1000);
            gl.add(e, {row: 1, column: 1});
            e.addListener("changeValue", changeN_u, this);
            this.gui_n_u = e;

            l = new qx.ui.basic.Label("n<sub>l</sub>:");
            l.setRich(true);
            gl.add(l, {row: 2, column: 0});
            e = new qx.ui.form.Spinner(1, this.plasma.r.getN_l(),
                this.plasma.r.getN_u() - 1);
            gl.add(e, {row: 2, column: 1});
            e.addListener("changeValue", changeN_l, this);
            this.gui_n_l = e;
        },

        renderExplorerTab : function()
        {
            var page_id = this.renderTabPage("Explorer",
                "pf/image/tab-explorer.png", false);
            page_id.setLayout(new qx.ui.layout.VBox);

            var sp = new qx.ui.splitpane.Pane("horizontal");
            sp.setDecorator("main");
            page_id.add(sp, {height: "100%"});
            
            // Create container with fixed dimensions for the left:
            var left_pane = new qx.ui.container.Composite(new qx.ui.layout.Grow).set({
              width: 250
            });

            // Create container for the right:
            var right_pane = new qx.ui.container.Composite(new qx.ui.layout.VBox(4)).set({
              padding : 4
            });

            sp.add(left_pane,  0, {flex: 1});
            sp.add(right_pane, 1, {flex: 2});

            
            var tree = new qx.ui.tree.Tree("Browser");
            tree.setDecorator(null);
            left_pane.add(tree);
            
            this.entity_tree = tree;
            
            var folder;
            
            var root = new qx.ui.tree.TreeFolder("Root");
            root.setOpen(true);
            tree.setRoot(root);
            tree.setHideRoot(true);
            tree.setRootOpenClose(true);
            tree.setOpenMode("dblclick");

            tree.addListener("changeSelection", clickTreeCB, this);
            
            folder = new qx.ui.tree.TreeFolder("Dimensionless");
            root.add(folder);
            this.gui_folder_none = folder;

            folder = new qx.ui.tree.TreeFolder("Length");
            root.add(folder);
            this.gui_folder_length = folder;
            
            folder = new qx.ui.tree.TreeFolder("Frequency");
            root.add(folder);
            this.gui_folder_freq = folder;

            folder = new qx.ui.tree.TreeFolder("Velocity");
            root.add(folder);
            this.gui_folder_vel = folder;
            
            folder = new qx.ui.tree.TreeFolder("Area");
            root.add(folder);
            this.gui_folder_area = folder;

            folder = new qx.ui.tree.TreeFolder("Mass density");
            root.add(folder);
            this.gui_folder_mass_density = folder;

            folder = new qx.ui.tree.TreeFolder("Energy");
            root.add(folder);
            this.gui_folder_energy = folder;

            folder = new qx.ui.tree.TreeFolder("Pressure");
            root.add(folder);
            this.gui_folder_pressure = folder;

            folder = new qx.ui.tree.TreeFolder("Power density");
            root.add(folder);
            this.gui_folder_power_density = folder;

            folder = new qx.ui.tree.TreeFolder("Power spectral density");
            root.add(folder);
            this.gui_folder_spectral_power_density = folder;

            folder = new qx.ui.tree.TreeFolder("Electric field");
            root.add(folder);
            this.gui_folder_efield = folder;

            

            this.populateTree();

            // Build context-sensitive popup menu
            this.treeMenu = new qx.ui.menu.Menu;
            var button;
            
            button = new qx.ui.menu.Button("Add to Favorites",
                "pf/image/favorite-add.png");
            button.addListener("execute", addToFavCB, this);
            this.treeMenu.add(button);
            this.treeMenuButtonAddToFav = button;
            button = new qx.ui.menu.Button("Remove from Favorites",
                "pf/image/favorite-delete.png");
            button.addListener("execute", removeFromFavCB, this);
            this.treeMenu.add(button);
            this.treeMenuButtonRemFromFav = button;
            
            this.doc.add(this.treeMenu);


            var layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnFlex(0, 3);
            layout.setColumnFlex(1, 12);
            layout.setColumnFlex(2, 4);
            layout.setColumnMinWidth(0,  50);
            layout.setColumnMaxWidth(2, 150);
            var gl = new qx.ui.container.Composite(layout);
            
            var l, e;
            

            l = new qx.ui.basic.Label("Name:");
            gl.add(l, {row: 0, column: 0});
            e = new qx.ui.form.TextField();
            e.setReadOnly(true);
            this.gui_entity_name = e;
            gl.add(e, {row: 0, column: 1, colSpan: 2});

            l = new qx.ui.basic.Label("Value:");
            gl.add(l, {row: 1, column: 0});
            e = new pf.ui.TextField("");
            e.setReadOnly(true);
            gl.add(e, {row: 1, column: 1});
            this.gui_entity_value = e;

            e = new pf.UnitSelector();
            e.addListener("changeSelection", changeUnitsCB, this);
            gl.add(e, {row: 1, column: 2});
            this.gui_entity_units = e;

            l = new qx.ui.basic.Label("Section:");
            gl.add(l, {row: 2, column: 0});
            e = new qx.ui.form.TextField();
            e.setReadOnly(true);
            this.gui_entity_section = e;
            gl.add(e, {row: 2, column: 1, colSpan: 2});

            right_pane.add(gl);

            var fr = new qx.ui.groupbox.GroupBox("Wikipedia article",
                "pf/image/wikipedia.png");
            fr.setLayout(new qx.ui.layout.Grow());
            
            var iframe = new qx.ui.embed.Iframe();
            iframe.addListener("load", function(ev) {
                    this.setCursor("default");
                });
            
            fr.add(iframe);
            right_pane.add(fr, {flex: 1});
            
            this.gui_wiki = iframe;
        },
        
        renderCompareTab : function()
        {
            var page_id = this.renderTabPage("Compare",
                "pf/image/tab-compare.png");
            page_id.setLayout(new qx.ui.layout.VBox(1));
            
            var bl = new qx.ui.container.Composite(new qx.ui.layout.VBox(10));
            page_id.add(bl, {height: "100%"});
            
            var rc = new qx.ui.container.Composite(new qx.ui.layout.HBox(10));
            bl.add(rc);

            var l, e;
            l = new qx.ui.basic.Label("Dimension:");
            rc.add(l);
            e = new pf.ui.SelectBox;
            e.addItem("None", "none");
            e.addItem("Length", "length");
            e.addItem("Frequency", "frequency");
            e.addItem("Velocity", "velocity");
            e.addItem("Area", "area");
            e.addItem("Energy", "energy");
            e.addItem("Mass density", "mass_density");
            e.addItem("Pressure", "pressure");
            e.addItem("Power density", "power_density");
            e.addItem("Power spectral density", "spectral_power_density");
            e.addItem("Electric field", "efield");
            e.addListener("changeSelection", function(ev) {
                    var dimension = this.gui_compare_dim.getSelectedValue();
                    this.gui_compare_units.update(dimension,
                        this.prefs.units[dimension]);
                    this.updateFavoritesListView();
                    this.updateLegendListView();
                }, this);
            rc.add(e);
            this.gui_compare_dim = e;
            
            l = new qx.ui.basic.Label("Units:");
            rc.add(l);
            e = new pf.UnitSelector();
            e.update("none");
            e.addListener("changeSelection", function(ev) {
                    this.updateFavoritesListView();
                }, this);
            rc.add(e);
            this.gui_compare_units = e;

            // table model
            var tm = new qx.ui.table.model.Simple();
            tm.setColumns([ "", "Name", "Section", "Value" ]);
            
            tm.setColumnEditable(0, false);
            tm.setColumnEditable(1, false);
            tm.setColumnEditable(2, false);
            tm.setColumnEditable(3, false);
            
            tm.setColumnSortable(0, false);
            
            tm.setSortMethods(3, function(row1, row2) {
                var obj1 = parseFloat(row1[arguments.callee.columnIndex]);
                var obj2 = parseFloat(row2[arguments.callee.columnIndex]);
                return (obj1 > obj2) ? 1 : ((obj1 == obj2) ? 0 : -1);
            });
            
            // table list
            var lv = new qx.ui.table.Table(tm);

            lv.setStatusBarVisible(false);
            lv.setShowCellFocusIndicator(false);
            lv.setColumnVisibilityButtonVisible(false);
            
            lv.setColumnWidth(0,  24);
            lv.setColumnWidth(1, 300);
            lv.setColumnWidth(2, 120);
            
            var renderer = new qx.ui.table.cellrenderer.Image(16, 16);
            lv.getTableColumnModel().setDataCellRenderer(0, renderer);

            bl.add(lv, {flex: 1});
            
            this.favoritesListView = lv;
        },
        
        drawAll : function(ev)
        {
            var canvas = this.canvas;
            
            canvas.setPrintable(true);
            
            var pname = this.guiParameter.getSelectedValue();
            var vmin = this.guiMinParam.getNumValue();
            var vmax = this.guiMaxParam.getNumValue();
            var npoints = this.guiParamPoints.getValue();
            
            if (npoints < 2 || !pname) {
                return;
            }

            var dimension = this.gui_compare_dim.getSelectedValue();
            var scale = this.gui_compare_units.getSelectedValue();

            var par0, au_f;
            var xlabel, ylabel;
            if (dimension == "none") {
                ylabel = "";
            } else {
                ylabel = this.gui_compare_dim.getSelectedLabel() + " (" +
                         this.gui_compare_units.getSelectedLabel() + ")";
            }
            switch (pname) {
            case "N_e":
                par0 = this.plasma.e.getN();
                au_f = pf.base.Bohr.n0;
                xlabel = "N<sub>e</sub> (cm<sup>-3</sup>)"
                break;
            case "T":
                par0 = this.plasma.e.getT();
                if (par0 != this.plasma.i.getT()) {
                    this.msgWindow.error("Cannot vary T since T<sub>e</sub> &ne; T<sub>i</sub>");
                    return;
                }
                if (par0 != this.plasma.r.getT()) {
                    this.msgWindow.error("Cannot vary T since T<sub>e</sub> &ne; T<sub>r</sub>");
                    return;
                }
                au_f = pf.base.Bohr.E0;
                xlabel = "T (eV)"
                break;
            case "T_e":
                par0 = this.plasma.e.getT();
                au_f = pf.base.Bohr.E0;
                xlabel = "T<sub>e</sub> (eV)"
                break;
            case "T_i":
                par0 = this.plasma.i.getT();
                au_f = pf.base.Bohr.E0;
                xlabel = "T<sub>i</sub> (eV)"
                break;
            case "T_r":
                par0 = this.plasma.r.getT();
                au_f = pf.base.Bohr.E0;
                xlabel = "T<sub>r</sub> (eV)"
                break;
            case "T_i,r":
                par0 = this.plasma.i.getT();
                if (par0 != this.plasma.r.getT()) {
                    this.msgWindow.error("Cannot vary T<sub>i,r</sub> since T<sub>i</sub> &ne; T<sub>r</sub>");
                    return;
                }
                au_f = pf.base.Bohr.E0;
                xlabel = "T<sub>i,r</sub> (eV)"
                break;
            case "P_r":
                par0 = this.plasma.P_r;
                au_f = 100;
                xlabel = "P<sub>r</sub> (%)"
                break;
            case "B":
                par0 = this.plasma.B;
                au_f = pf.base.Bohr.B0;
                xlabel = "B (T)"
                break;
            default:
                return;
            }
            
            if (par0 == 0) {
                this.msgWindow.error("Cannot vary a null parameter</sub>");
                return;
            }
            if (vmin >= vmax) {
                this.msgWindow.error("Min. scale must be less than max. one");
                return;
            }
            if (vmin <= 0) {
                this.msgWindow.error("Non-positive scale values are not allowed");
                return;
            }
            
            var x_au  = new Array;
            var xdata = new Array;
            for (var j = 0; j < npoints; j++) {
                var x = par0*(vmin + (vmax - vmin)*j/(npoints - 1));
                x_au.push(x);
                xdata.push(au_f*x);
            }
                        
            var wxmin = xdata[0];
            var wxmax = xdata[xdata.length - 1];

            var wymin = 0;
            var wymax = 0;

            var sets = new Array;
            var first = true;
            for (var i = 0; i < this.favorites.length; i++) {
                var fav = this.favorites[i];
                var entity = fav.entity;
                
                if (entity.dimension != dimension) {
                    continue;
                }
                
                var s1    = fav.s1;
                var s2    = fav.s2;
                var vname = this.getEntityFullName(entity, s1, s2);

                var set   = new Object;
                var ydata = new Array;
                for (var j = 0; j < npoints; j++) {
                    var par = x_au[j];

                    switch (pname) {
                    case "N_e":
                        this.plasma.e.setN(par);
                        this.updatePlasmaParameters();
                        break;
                    case "T_e":
                        this.plasma.e.setT(par);
                        break;
                    case "T_i":
                        this.plasma.i.setT(par);
                        break;
                    case "T_r":
                        this.plasma.r.setT(par);
                        break;
                    case "T_i,r":
                        this.plasma.i.setT(par);
                        this.plasma.r.setT(par);
                        break;
                    case "T":
                        this.plasma.e.setT(par);
                        this.plasma.i.setT(par);
                        this.plasma.r.setT(par);
                        break;
                    case "P_r":
                        this.plasma.P_r = par;
                        this.updatePlasmaParameters();
                        break;
                    case "B":
                        this.plasma.B = par;
                        break;
                    }
                    
                    var value = scale*this.evaluateEntityValue(entity, s1, s2);
                    
                    if (first) {
                        wymin = value;
                        wymax = value;
                        first = false;
                    } else {
                        if (value < wymin) {
                            wymin = value;
                        }
                        if (value > wymax) {
                            wymax = value;
                        }
                    }
                    
                    ydata.push(value);
                }
                set.x = xdata;
                set.y = ydata;
                set.legend = vname;
                set.color = fav.color;
                sets.push(set);
            }
            
            // Restore parameter
            switch (pname) {
            case "N_e":
                this.plasma.e.setN(par0);
                this.updatePlasmaParameters();
                break;
            case "T_e":
                this.plasma.e.setT(par0);
                break;
            case "T_i":
                this.plasma.i.setT(par0);
                break;
            case "T_r":
                this.plasma.r.setT(par0);
                break;
            case "T_i,r":
                this.plasma.i.setT(par0);
                this.plasma.r.setT(par0);
                break;
            case "T":
                this.plasma.e.setT(par0);
                this.plasma.i.setT(par0);
                this.plasma.r.setT(par0);
                break;
            case "P_r":
                this.plasma.P_r = par0;
                this.updatePlasmaParameters();
                break;
            case "B":
                this.plasma.B = par0;
                break;
            }
            
            canvas.clear();
            
            canvas.setViewportCoordinates(0.15, 0.1, 0.9, 0.9);
            var dwx = Math.abs(wxmax - wxmin);
            if (dwx == 0) {
                dwx = wxmax;
            }
            var dwy = Math.abs(wymax - wymin);
            if (dwy == 0) {
                wymin = 0.0;
                if (wymax == 0) {
                    wymax = 1.0;
                } else {
                    wymax *= 2;
                }
            }
            
            // If Y max & min of the same sign and differ significantly, set
            // the smallest (by abs value) limit to 0
            var wymin_r, wymax_r;
            if (wymin > 0 && wymax/wymin > 3) {
                wymin_r = 0;
                wymax_r = wymax + 0.05*dwy;
            } else
            if (wymax < 0 && wymin/wymax > 3) {
                wymin_r = wymin - 0.05*dwy
                wymax_r = 0;
            } else {
                wymin_r = wymin < 0 ?
                    (wymin - 0.05*dwy) : Math.max(0, wymin - 0.05*dwy);
                wymax_r = wymax + 0.05*dwy;
            }
            
            var wxmin_r =
                wxmin < 0 ? (wxmin - 0.05*dwx) : Math.max(0, wxmin - 0.05*dwx);
            canvas.setWorldCoordinates(wxmin_r, wymin_r,
                wxmax + 0.05*dwx, wymax_r);
            
            // Draw frame
            canvas.setStroke(1);
            canvas.drawFrame("black");

            // Mark initial value of the varied parameter
            canvas.setColor("#c0c0c0");
            canvas.setStroke(-1);
            canvas.drawPolyLineW([par0*au_f, par0*au_f], [wymin_r, wymax_r]);
            
            // Draw title
            canvas.drawTitle(this.prefs.currentConfigName, "black");
            
            // Draw axis ticks
            canvas.setStroke(1);
            canvas.drawTicks("x", "blue");
            canvas.drawTicks("y", "blue");

            // Draw axis labels
            canvas.drawLabel("x", xlabel, "black");
            canvas.drawLabel("y", ylabel, "black");
            
            // Draw sets
            canvas.setStroke(2);
            for (var i = 0; i < sets.length; i++) {
                var set = sets[i];
                canvas.setColor(set.color);
                canvas.drawPolyLineW(set.x, set.y);
                
                delete set;
            }
            
            delete sets;
            
            canvas.paint();
        },

        showWikiPage : function(entity)
        {
            var url = "about:blank";
            if (entity && entity.wikiLink) {
                url = "http://en.wikipedia.org/w/index.php?title=" +
                      entity.wikiLink + "&printable=yes";
            }
            
            this.gui_wiki.setCursor("wait");
            this.gui_wiki.setSource(url);
        },
        
        loadWikiCB : function(ev)
        {
            var tree = this.entity_tree;
            var leaf = getSingleTreeSelectedItem(tree);
            
            if (!leaf) {
                return;
            }
            
            var entity = leaf.getUserData("entity");
            
            this.showWikiPage(entity);
        },
        
        drawCB : function(ev)
        {
            this.drawAll();
        },
        
        renderPlotTab : function()
        {
            var page_id = this.renderTabPage("Plot",
                "pf/image/tab-plot.png");
            page_id.setLayout(new qx.ui.layout.VBox);

            var sp = new qx.ui.splitpane.Pane("horizontal");
            sp.setDecorator("main");
            page_id.add(sp, {height: "100%"});
                        
            var left_pane = new qx.ui.container.Composite(new qx.ui.layout.Grow);
            var right_pane = new qx.ui.container.Composite(new qx.ui.layout.VBox(4)).set({
              padding : 4
            });

            sp.add(left_pane,  2);
            sp.add(right_pane, 1);
            
            var canvas = new pf.ui.canvas.Plotter();
            left_pane.add(canvas);
            this.canvas = canvas;

            var layout = new qx.ui.layout.Grid(4, 6);
            layout.setColumnWidth(0, 100);
            layout.setColumnFlex(1, 1);
            var gl = new qx.ui.container.Composite(layout);

            var l, e;

            var btn = new qx.ui.form.Button("Redraw", "pf/image/tab-plot.png");
            btn.addListener("execute", this.drawCB, this);
            gl.add(btn, {row: 0, column: 0});

            l = new qx.ui.basic.Label("Parameter to vary:");
            e = new pf.ui.SelectBox;
            e.addItem("N<sub>e</sub>",   "N_e", true);
            e.addItem("T",               "T");
            e.addItem("T<sub>e</sub>",   "T_e", true);
            e.addItem("T<sub>i</sub>",   "T_i", true);
            e.addItem("T<sub>r</sub>",   "T_r", true);
            e.addItem("T<sub>i,r</sub>", "T_i,r", true);
            e.addItem("P<sub>r</sub>",   "P_r", true);
            e.addItem("B",               "B");
            e.selectByValue("N_e");
            this.guiParameter = e;
            gl.add(l, {row: 1, column: 0});
            gl.add(e, {row: 1, column: 1});

            l = new qx.ui.basic.Label("Minimum scale:");
            e = new pf.ui.TextField(0.5);
            this.guiMinParam = e;
            gl.add(l, {row: 2, column: 0});
            gl.add(e, {row: 2, column: 1});

            l = new qx.ui.basic.Label("Maximum scale:");
            e = new pf.ui.TextField(2.0);
            this.guiMaxParam = e;
            gl.add(l, {row: 3, column: 0});
            gl.add(e, {row: 3, column: 1});

            l = new qx.ui.basic.Label("Number of points:");
            e = new qx.ui.form.Spinner(2, 20, 100);
            this.guiParamPoints = e;
            gl.add(l, {row: 4, column: 0});
            gl.add(e, {row: 4, column: 1});

            right_pane.add(gl);



            var tm = new qx.ui.table.model.Simple();
            tm.setColumns(["", "Name", "Favorite"],
                          ["color", "name", "favorite"]);
            
            tm.setColumnEditable(0, false);
            tm.setColumnEditable(1, false);
            
            tm.setColumnSortable(0, false);
            
            // table list
            var lv = new qx.ui.table.Table(tm);

            var cm = lv.getTableColumnModel();
            cm.setColumnVisible(2, false);
            
            lv.setStatusBarVisible(false);
            lv.setShowCellFocusIndicator(false);
            lv.setColumnVisibilityButtonVisible(false);
            
            lv.setColumnWidth(0,  22);
            lv.setColumnWidth(1, 220);
            
            var renderer = new pf.ui.table.cellrenderer.BgColor();
            lv.getTableColumnModel().setDataCellRenderer(0, renderer);

            right_pane.add(lv, {flex: 1});
            this.legendListView = lv;
            
            var sm = lv.getSelectionModel();
            
            lv.addListener("dblclick", function(ev) {
                    ev.stopPropagation();

                    if (sm.isSelectionEmpty()) {
                        return;
                    }
                    
                    var index = sm.getLeadSelectionIndex();
                    var item = tm.getRowDataAsMap(index);

                    var favorite = item.favorite;
                    if (!favorite) {
                        return;
                    }
                    cpop.setUserData("favorite", null); // avoid loop call
                    cpop.setValue(favorite.color);
                    cpop.setUserData("favorite", favorite);
                    
                    cpop.placeToMouse(ev);
                    cpop.open();
                });

            var cpop = new pf.ui.ColorPopup(this.colorMap);
            cpop.exclude();

            this.doc.add(cpop);

            cpop.addListener("changeValue", function(ev) {
                    var color = ev.getData();
                    var cpop = ev.getTarget();
                    var favorite = cpop.getUserData("favorite");
                    if (!favorite || !color) {
                        return;
                    }
                    favorite.color = color;
                    this.updateLegendListView();
                    this.drawAll();
                    this.saveFavorites();
                }, this);
        
            // drawAll is an expensive operation, so call it only when
            // this tab is selected
            this.tabview.addListener("changeSelection", function(ev) {
                    if (ev.getData()[0] == page_id) {
                        this.drawAll();
                    }
                }, this);
        },


        aboutCB : function(ev)
        {
            this.aboutWindow.open();
        },
        
        prefsCB : function(ev)
        {
            this.prefsWindow.open();
        },
        
        updateSaveLoadList : function()
        {
            var lv = this.saveLoadConfigList;
            var tm = lv.getTableModel();
            
            var configPtrs = this.prefs.configPtrs;
            
            var rowData = new Array();

            var i;
            var d = new Date();
            var df = new qx.util.format.DateFormat("yyyy-MM-dd HH:mm:ss");
            
            for (i = 0; i < configPtrs.length; i++) {
                var configPtr = configPtrs[i];

                d.setTime(configPtr.time);

                rowData.push([configPtr.name, df.format(d)]);
            }
            
            tm.setData(rowData, false);
            var sidx = tm.getSortColumnIndex();
            tm.sortByColumn(sidx, tm.isSortAscending());
            
            lv.updateContent();
        },
        
        saveAsCB : function(ev)
        {
            var w = this.saveLoadWindow;
            
            this.updateSaveLoadList();
            this.saveLoadTextField.setValue(null);
            this.saveLoadTextField.setReadOnly(false);
            
            w.setCaption("Save configuration")
            w.setIcon("pf/image/save.png");
            w.setUserData("type", "save");
            
            w.open();
        },
        
        saveConfigCB : function(ev)
        {
            if (this.prefs.currentConfigName &&
                this.prefs.currentConfigName != "Untitled") {
                if (this.saveConfig(this.prefs.currentConfigName) != true) {
                    this.msgWindow.error("Save failed!");
                }
            } else {
                this.saveAsCB(ev);
            }
        },
        
        openCB : function(ev)
        {
            var w = this.saveLoadWindow;
            
            this.updateSaveLoadList();
            this.saveLoadTextField.setValue(null);
            this.saveLoadTextField.setReadOnly(true);
            
            w.setCaption("Open configuration")
            w.setIcon("pf/image/open.png");
            w.setUserData("type", "open");
            
            w.open();
        },
        
        restart : function(force)
        {
            if (force || this.intendedExit || !this.prefs.warnOnExit) {
                location.reload(true);
            } else {
                this.confirmDialog.confirm("Restart Plasma Formulary?",
                    function(yesno) {
                            if (yesno) {
                                this.intendedExit = true;
                                this.restart(true);
                            }
                        }, this);
            }
        },
        
        quit : function(force)
        {
            if (force || this.intendedExit || !this.prefs.warnOnExit) {
                window.close(true);
            } else {
                this.confirmDialog.confirm("Quit Plasma Formulary?",
                    function(yesno) {
                            if (yesno) {
                                this.intendedExit = true;
                                this.quit(true);
                            }
                        }, this);
            }
        },
        
        buildMenu : function()
        {
            var menubar = this.menubar;
            
            var submenu, btn, q;

            submenu = new qx.ui.menu.Menu;
            this.doc.add(submenu);
            q = new qx.ui.core.Command("Ctrl+O");
            q.addListener("execute", this.openCB, this);
            btn = new qx.ui.menu.Button("Open...", "pf/image/open.png", q);
            submenu.add(btn);
            q = new qx.ui.core.Command("Ctrl+S");
            q.addListener("execute", this.saveConfigCB, this);
            btn = new qx.ui.menu.Button("Save", "pf/image/save.png", q);
            submenu.add(btn);
            btn = new qx.ui.menu.Button("Save as...", "pf/image/save.png");
            btn.addListener("execute", this.saveAsCB, this);
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            q = new qx.ui.core.Command("Ctrl+P");
            q.addListener("execute", function(ev) {
                window.print();
            });
            btn = new qx.ui.menu.Button("Print...", "pf/image/print.png", q);
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            q = new qx.ui.core.Command("Ctrl+R");
            q.addListener("execute", function(ev) {
                    this.restart(false);
                }, this);
            btn = new qx.ui.menu.Button("Restart", "pf/image/reset.png", q);
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            q = new qx.ui.core.Command("Ctrl+Q");
            q.addListener("execute", function(ev) {
                    this.quit(false);
                }, this);
            btn = new qx.ui.menu.Button("Quit", "pf/image/exit.png", q);
            submenu.add(btn);
                
            btn = new qx.ui.menubar.Button("File", null, submenu);
            menubar.add(btn);


            submenu = new qx.ui.menu.Menu;
            submenu.addListener("appear", editMenuCB, this);
            this.doc.add(submenu);
            btn = new qx.ui.menu.Button("Add to Favorites",
                "pf/image/favorite-add.png");
            btn.addListener("execute", addToFavCB, this);
            this.editMenuButtonAddToFav = btn;
            submenu.add(btn);
            btn = new qx.ui.menu.Button("Remove from Favorites",
                "pf/image/favorite-delete.png");
            btn.addListener("execute", removeFromFavCB, this);
            this.editMenuButtonRemFromFav = btn;
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            btn = new qx.ui.menu.Button("Preferences",
                "pf/image/preferences.png");
            btn.addListener("execute", this.prefsCB, this);
            submenu.add(btn);

            btn = new qx.ui.menubar.Button("Edit", null, submenu);
            menubar.add(btn);


            submenu = new qx.ui.menu.Menu;
            submenu.addListener("appear", viewMenuCB, this);

            var subMenu1 = new qx.ui.menu.Menu;
            btn = new qx.ui.menu.CheckBox("Fundamental");
            btn.setValue(this.showFundamental);
            btn.addListener("execute", showFundamentalCB, this);
            subMenu1.add(btn);
            btn = new qx.ui.menu.CheckBox("Spectroscopy");
            btn.setValue(this.showSpectroscopy);
            btn.addListener("execute", showSpectroscopyCB, this);
            subMenu1.add(btn);
            btn = new qx.ui.menu.CheckBox("Waves");
            btn.setValue(this.showWaves);
            btn.addListener("execute", showWavesCB, this);
            subMenu1.add(btn);
            btn = new qx.ui.menu.CheckBox("Collisions");
            btn.setValue(this.showCollisions);
            btn.addListener("execute", showCollisionsCB, this);
            subMenu1.add(btn);
            btn = new qx.ui.menu.CheckBox("Radiation");
            btn.setValue(this.showRadiation);
            btn.addListener("execute", showRadiationCB, this);
            subMenu1.add(btn);
            this.showSectionsButton = new qx.ui.menu.Button("Show Sections",
                null, null, subMenu1);
            submenu.add(this.showSectionsButton);
            
            submenu.add(new qx.ui.menu.Separator);

            var subMenu2 = new qx.ui.menu.Menu;
            btn = new qx.ui.menu.CheckBox("Electrons");
            btn.setValue(this.showElectrons);
            btn.addListener("execute", showElectronsCB, this);
            subMenu2.add(btn);
            btn = new qx.ui.menu.CheckBox("Ions");
            btn.setValue(this.showIons);
            btn.addListener("execute", showIonsCB, this);
            subMenu2.add(btn);
            btn = new qx.ui.menu.CheckBox("Radiators");
            btn.setValue(this.showRadiators);
            btn.addListener("execute", showRadiatorsCB, this);
            subMenu2.add(btn);
            this.showSpeciesButton = new qx.ui.menu.Button("Show Species",
                null, null, subMenu2);
            submenu.add(this.showSpeciesButton);
            
            submenu.add(new qx.ui.menu.Separator);
            q = new qx.ui.core.Command("Ctrl+W");
            q.addListener("execute", this.loadWikiCB, this);
            btn = new qx.ui.menu.Button("Load Wikipedia Article",
                "pf/image/wikipedia.png", q);
            submenu.add(btn);
            this.loadWikiButton = btn;
            this.doc.add(submenu);
            this.doc.add(subMenu1);
            this.doc.add(subMenu2);

            submenu.add(new qx.ui.menu.Separator);
            q = new qx.ui.core.Command("Ctrl+L");
            q.addListener("execute", this.drawCB, this);
            btn = new qx.ui.menu.Button("Redraw Plot",
                "pf/image/tab-plot.png", q);
            submenu.add(btn);
            this.redrawButton = btn;
            
            
            btn = new qx.ui.menubar.Button("View", null, submenu);
            menubar.add(btn);


            var nvOptions = {
                width: 850,
                scrollbars : true,
                resizable : true,
                menubar : false,
                status : false
            };
            submenu = new qx.ui.menu.Menu;
            this.doc.add(submenu);
            q = new qx.ui.core.Command("F1");
            q.addListener("execute", function(ev) {
                    var url = "resource/pf/html/ug.html";
                    var w = qx.bom.Window.open(url, null, nvOptions);
                }, this);
            btn = new qx.ui.menu.Button("Help Contents",
                "pf/image/help.png", q);
            submenu.add(btn);
            btn = new qx.ui.menu.Button("Reference Paper",
                "pf/image/jinst.png");
            btn.addListener("execute", function (ev) {
                    var url = "http://dx.doi.org/10.1088/1748-0221/6/10/P10009";
                    var w = qx.bom.Window.open(url, null, nvOptions);
                }, this);
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            btn = new qx.ui.menu.Button("NRL Plasma Formulary",
                "pf/image/nrl.png");
            btn.addListener("execute", function (ev) {
                    var url = "http://wwwppd.nrl.navy.mil/nrlformulary/";
                    var w = qx.bom.Window.open(url, null, nvOptions);
                }, this);
            submenu.add(btn);
            btn = new qx.ui.menu.Button("Plasma at Wikipedia",
                "pf/image/wikipedia.png");
            btn.addListener("execute", function (ev) {
                    var url = "http://en.wikipedia.org/wiki/Plasma_%28physics%29";
                    var w = qx.bom.Window.open(url, null, nvOptions);
                }, this);
            submenu.add(btn);
            submenu.add(new qx.ui.menu.Separator);
            btn = new qx.ui.menu.Button("License Terms",
                "pf/image/gnu.png");
            btn.addListener("execute", function (ev) {
                    var url = "resource/pf/html/GPL.html";
                    var w = qx.bom.Window.open(url, null, nvOptions);
                }, this);
            submenu.add(btn);
            btn = new qx.ui.menu.Button("About...",
                "pf/image/about.png");
            btn.addListener("execute", this.aboutCB, this);
            submenu.add(btn);

            btn = new qx.ui.menubar.Button("Help", null, submenu);
            menubar.add(btn);
        },
        
        getEntityById : function(id)
        {
            var len = plasma_entities.length;
            
            for (var i = 0; i < len; i++) {
                var entity = plasma_entities[i];
                if (entity.id == id) {
                    return entity;
                }
            }
            
            return null;
        },
        
        getSpeciesById : function(id)
        {
            switch (id) {
            case "e":
                return this.plasma.e;
                break;
            case "i":
                return this.plasma.i;
                break;
            case "r":
                return this.plasma.r;
                break;
            default:
                return null;
                break;
            }
        },
        
        nextColor : function()
        {
            var color = this.colorMap[this.ncolor];
            this.ncolor++;
            if (this.ncolor == this.colorMap.length) {
                this.ncolor = 0;
            }
            
            return color;
        },

        exportFavorites : function()
        {
            var sfavs = new Array;
            var len = this.favorites.length;
            
            for (var k = 0; k < len; k++) {
                var fav  = this.favorites[k];
                var sfav = new Object;
                sfav.entity_id  = fav.entity.id;
                if (fav.s1) {
                    sfav.s1_id = fav.s1.id;
                } else {
                    sfav.s1_id = null;
                }
                if (fav.s2) {
                    sfav.s2_id = fav.s2.id;
                } else {
                    sfav.s2_id = null;
                }
                sfav.color     = fav.color;
                sfavs.push(sfav);
            }
            
            return sfavs;
        },

        importFavorites : function(sfavs)
        {
            if (!sfavs) {
                return false;
            }

            this.favorites = new Array;
            
            var len = sfavs.length;
            for (var k = 0; k < len; k++) {
                var sfav = sfavs[k];
                var fav  = new Object;
                fav.entity = this.getEntityById(sfav.entity_id);
                // old format
                if (sfav.species_id) {
                    fav.s1 = this.getSpeciesById(sfav.species_id);
                } else
                if (sfav.s1_id) {
                    fav.s1 = this.getSpeciesById(sfav.s1_id);
                }

                if (sfav.s2_id) {
                    fav.s2 = this.getSpeciesById(sfav.s2_id);
                }
                fav.color = sfav.color;

                if (fav.entity && fav.color) {
                    this.favorites.push(fav);
                }
            }
            
            return true;
        },

        getConfig : function(name)
        {
            if (!name) {
                return null;
            }

            var configPtrs = this.prefs.configPtrs;
            
            var i, configPtr = null;
            for (i = 0; i < configPtrs.length; i++) {
                if (configPtrs[i].name == name) {
                    configPtr = configPtrs[i];
                    return configPtr;
                    break;
                }
            }
            
            return null;
        },
        
        savePreferences : function()
        {
            if (this.prefs) {
                var prefstr = qx.lang.Json.stringify(this.prefs);
                qx.bom.Cookie.set("pf_prefs", prefstr, 3650);
            }
        },
        
        loadPreferences : function()
        {
            var prefstr = qx.bom.Cookie.get("pf_prefs");
            
            if (prefstr) {
                this.prefs = qx.lang.Json.parse(prefstr);
            }
            
            if (!this.prefs) {
                this.prefs = new Object;
            }
 
            if (undefined === this.prefs.saveFavsWithConfig) {
                this.prefs.saveFavsWithConfig = true;
            }
            
            if (undefined === this.prefs.rememberWindowSize) {
                this.prefs.rememberWindowSize = false;
            }

            if (undefined === this.prefs.autoLoadWiki) {
                this.prefs.autoLoadWiki = true;
            }
            
            if (undefined === this.prefs.warnOnExit) {
                this.prefs.warnOnExit = true;
            }
            
            if (!this.prefs.units) {
                this.prefs.units = new Object;
            }
            
            if (!this.prefs.currentConfigName) {
                this.prefs.currentConfigName = "Untitled";
            }
            
            if (!this.prefs.configPtrs) {
                this.prefs.configPtrs = new Array;
            }
        },
        
        saveFavorites : function()
        {
            var sfavs = this.exportFavorites();
            
            var favstr = qx.lang.Json.stringify(sfavs);
            
            qx.bom.Cookie.set("pf_favs", favstr, 3650);
        },
        
        loadFavorites : function()
        {
            this.favorites = new Array;
            
            var favstr = qx.bom.Cookie.get("pf_favs");
            
            if (favstr) {
                var sfavs = qx.lang.Json.parse(favstr);
                
                this.importFavorites(sfavs);
            }
        },
        
        saveConfig : function(name)
        {
            if (!name) {
                return false;
            }

            var configPtr = this.getConfig(name);
            
            var d = new Date();
            var time = d.getTime();
            
            if (!configPtr) {
                configPtr = new Object;
                configPtr.name = name;
                configPtr.hash = time;
                this.prefs.configPtrs.push(configPtr);
            }
            
            configPtr.time = time;
            
            var cookie_name = "pf_config_" + configPtr.hash;
            
            var config = new Object;
            
            // version of config format
            config.format_v = 1;
            
            config.N_e = this.plasma.e.getN();

            config.T_e = this.plasma.e.getT();
            config.T_i = this.plasma.i.getT();
            config.T_r = this.plasma.r.getT();

            config.M_i = this.plasma.i.getM();
            config.M_r = this.plasma.r.getM();
            
            config.Q_i = this.plasma.i.getQ();
            config.Q_r = this.plasma.r.getQ();

            config.P_r = this.plasma.P_r;

            config.B   = this.plasma.B  ;

            config.n_u = this.plasma.r.getN_u();
            config.n_l = this.plasma.r.getN_l();
            
            if (this.prefs.saveFavsWithConfig) {
                config.favorites = this.exportFavorites();
            }
            
            var configstr = qx.lang.Json.stringify(config);
            qx.bom.Cookie.set(cookie_name, configstr, 3650);
            
            this.prefs.currentConfigName = name;
            this.savePreferences();
            
            return true;
        },
        
        loadConfig : function(name)
        {
            var configPtr = this.getConfig(name);
            if (!configPtr) {
                return false;
            }

            var cookie_name = "pf_config_" + configPtr.hash;

            var configstr = qx.bom.Cookie.get(cookie_name);
            if (!configstr) {
                // Cookie was deleted???
                qx.lang.Array.remove(this.prefs.configPtrs, configPtr);
                return false;
            }

            var config = qx.lang.Json.parse(configstr);
            
            if (config) {
                var au_fn, au_fT, au_fM, au_fB;
                if (!config.format_v) {
                    // old format, rescale data
                    au_fn = pf.base.Bohr.n0;
                    au_fT = pf.base.Bohr.E0;
                    au_fM = 1/pf.base.Bohr.m_p;
                    au_fB = pf.base.Bohr.B0;
                } else {
                    au_fn = 1;
                    au_fT = 1;
                    au_fM = 1;
                    au_fB = 1;
                }
                
                this.plasma.e.setN(config.N_e/au_fn);

                this.plasma.e.setT(config.T_e/au_fT);
                this.plasma.i.setT(config.T_i/au_fT);
                this.plasma.r.setT(config.T_r/au_fT);

                this.plasma.i.setM(config.M_i/au_fM);
                this.plasma.r.setM(config.M_r/au_fM);

                this.plasma.i.setQ(config.Q_i);
                this.plasma.r.setQ(config.Q_r);

                this.plasma.P_r = config.P_r;

                this.plasma.B   = config.B/au_fB;

                this.plasma.r.setN_u(config.n_u);
                this.plasma.r.setN_l(config.n_l);
                
                if (this.prefs.saveFavsWithConfig && config.favorites) {
                    this.importFavorites(config.favorites);
                }

                this.prefs.currentConfigName = name;
                
                this.savePreferences();

                return true;
            } else {
                return false;
            }
        },
        
        removeConfig : function(name)
        {
            var configPtr = this.getConfig(name);
            if (configPtr) {
                qx.lang.Array.remove(this.prefs.configPtrs, configPtr);
                var cookie_name = "pf_config_" + configPtr.hash;
                qx.bom.Cookie.del(cookie_name);
                this.savePreferences();
            }
        },
        
        renameConfig : function(oldname, newname)
        {
            var configPtr = this.getConfig(oldname);
            if (configPtr) {
                configPtr.name = newname;
                this.savePreferences();
            }
        },
        
        createSaveLoadDialog : function()
        {
            var w, layout, rc1, e, btn;
            // "Save as..." dialog
            w = new pf.ui.DialogWindow();
            w.setLayout(new qx.ui.layout.VBox(0));
            w.setContentPadding(0);
                
            this.doc.add(w);
            this.saveLoadWindow = w;

            var tb = new qx.ui.toolbar.ToolBar();
            var tbpart = new qx.ui.toolbar.Part();
            var btn_delete = new qx.ui.toolbar.Button("Delete",
                "pf/image/delete.png");
            var btn_rename = new qx.ui.toolbar.Button("Rename",
                "pf/image/rename.png");
            var btn_export = new qx.ui.toolbar.Button("Export",
                "pf/image/export.png");
            var btn_import = new qx.ui.toolbar.Button("Import",
                "pf/image/import.png");
            btn_delete.setEnabled(false);
            btn_rename.setEnabled(false);
            btn_export.setEnabled(false);
            tbpart.add(btn_delete);
            tbpart.add(btn_rename);
            tbpart.add(new qx.ui.toolbar.Separator());
            tbpart.add(btn_export);
            tbpart.add(btn_import);
            tb.add(tbpart);
            w.add(tb);

            // table model
            var tm = new qx.ui.table.model.Simple();
            tm.setColumns([ "Configuration", "Last Modified" ]);
            
            tm.setColumnEditable(0, false);
            tm.setColumnEditable(1, false);
            
            // table list
            var lv = new qx.ui.table.Table(tm);
            lv.set({
                height: 250
            });

            lv.setStatusBarVisible(false);
            lv.setShowCellFocusIndicator(false);
            lv.setColumnVisibilityButtonVisible(false);
            
            lv.setColumnWidth(0, 250);
            lv.setColumnWidth(1, 150);
            
            var renderer = new qx.ui.table.cellrenderer.Html();
            lv.getTableColumnModel().setDataCellRenderer(0, renderer);
            
            this.saveLoadConfigList = lv;
            w.add(lv);

            var sm = lv.getSelectionModel();
            sm.setSelectionMode(qx.ui.table.selection.Model.SINGLE_SELECTION);
            
            // Export/import window
            var eiw = new pf.ui.DialogWindow();
            eiw.set({
                width:  350,
                height: 400
            });
            eiw.setResizable(true);
            eiw.setLayout(new qx.ui.layout.VBox(0));
            eiw.setContentPadding(0);
            
            var note = new qx.ui.basic.Label("Label", {height: 20});
            eiw.add(note);
                
            var text_area = new qx.ui.form.TextArea();
            text_area.setWrap(true);
            eiw.add(text_area, {flex: 1});


            layout = new qx.ui.layout.HBox(10, "right");
            rc1 = new qx.ui.container.Composite(layout);
            rc1.setMargin(10, 10, 10, 10);
            eiw.add(rc1);

            btn = new qx.ui.form.Button("Cancel", "pf/image/cancel.png");
            btn.addListener("execute", function(ev) {
                    eiw.close();
                }, this);
            rc1.add(btn);

            btn = new qx.ui.form.Button("OK", "pf/image/ok.png");
            btn.addListener("execute", function(ev) {
                    var type = eiw.getUserData("type");
                    if (type == "import") {
                        var configstr = text_area.getValue();
                        
                        var config;
                        try {
                            config = qx.lang.Json.parse(configstr);
                        } catch (err) {
                            this.error(err);
                        }

                        if (config) {
                            var name = config.name;
                            
                            var d = new Date();
                            var time = d.getTime();
            
                            var configPtr = new Object;
                            configPtr.name = name;
                            configPtr.hash = time;
                            configPtr.time = time;
                            
                            this.prefs.configPtrs.push(configPtr);
                            
                            var cookie_name = "pf_config_" + configPtr.hash;
                            qx.bom.Cookie.set(cookie_name, configstr, 3650);
                            
                            this.savePreferences();
                            this.updateSaveLoadList();
                            
                            eiw.close();
                        } else {
                            this.msgWindow.error("Cannot parse the configuration!");
                        }
                    } else {
                        eiw.close();
                    }
                }, this);
            rc1.add(btn);
            
            this.doc.add(eiw);

            btn_delete.addListener("execute", function(ev) {
                    if (!sm.isSelectionEmpty()) {
                        var index = sm.getLeadSelectionIndex();
                        var rowData = tm.getRowData(index);
                        var name = rowData[0];
                        if (name == this.prefs.currentConfigName) {
                            this.msgWindow.error("Cannot delete current configuration!");
                        } else {
                            this.confirmDialog.confirm("Delete \"" + name + "\"?",
                                function(yesno) {
                                        if (yesno) {
                                            this.removeConfig(name);
                                            this.updateSaveLoadList();
                                        }
                                    }, this);
                        }
                    }
                }, this);

            btn_rename.addListener("execute", function(ev) {
                    if (!sm.isSelectionEmpty()) {
                        var index = sm.getLeadSelectionIndex();
                        var rowData = tm.getRowData(index);
                        var name = rowData[0];
                        
                        this.promptDialog.prompt("Rename \"" + name + "\" to",
                            name, function(newname) {
                                    if (newname  && newname != name) {
                                        this.renameConfig(name, newname);
                                        this.updateSaveLoadList();
                                        if (name == this.prefs.currentConfigName) {
                                            this.prefs.currentConfigName = newname;
                                            this.gui_configName.setLabel(newname);
                                        }
                                        this.saveLoadTextField.setValue(newname);
                                    }
                                }, this);
                    }
                }, this);

            btn_export.addListener("execute", function(ev) {
                    if (!sm.isSelectionEmpty()) {
                        var index = sm.getLeadSelectionIndex();
                        var rowData = tm.getRowData(index);
                        var name = rowData[0];
                        
                        var configPtr = this.getConfig(name);
                        if (!configPtr) {
                            return false;
                        }

                        var cookie_name = "pf_config_" + configPtr.hash;

                        var configstr = qx.bom.Cookie.get(cookie_name);
                        if (!configstr) {
                            return false;
                        }

                        var config = qx.lang.Json.parse(configstr);
                        config.name = name;

                        text_area.setValue(
                            qx.lang.Json.stringify(config, undefined, 4));
                        
                        eiw.setCaption("Export configuration")
                        eiw.setIcon("pf/image/export.png");
                        eiw.setUserData("type", "export");
                        
                        text_area.setReadOnly(true);
                        
                        var nstr =
                            "Copy the contents below to a text editor and save";
                        note.setValue(nstr);
                        
                        eiw.open();
                    }
                }, this);

            btn_import.addListener("execute", function(ev) {
                    eiw.setCaption("Import configuration")
                    eiw.setIcon("pf/image/import.png");
                    eiw.setUserData("type", "import");

                    text_area.setReadOnly(false);
                    text_area.setValue("");

                    var nstr =
                        "Copy a previously saved config to the space below";
                    note.setValue(nstr);

                    eiw.open();
                }, this);

            e = new qx.ui.form.TextField();
            e.setMarginTop(1);
            w.add(e);
            this.saveLoadTextField = e;
            
            sm.addListener("changeSelection", function(ev) {
                    if (sm.isSelectionEmpty()) {
                        e.setValue(null);
                        btn_delete.setEnabled(false);
                        btn_rename.setEnabled(false);
                        btn_export.setEnabled(false);
                    } else {
                        var index = sm.getLeadSelectionIndex();
                        var rowData = tm.getRowData(index);
                        e.setValue(rowData[0]);
                        btn_rename.setEnabled(true);
                        btn_delete.setEnabled(true);
                        btn_export.setEnabled(true);
                    }
                });
            
            layout = new qx.ui.layout.HBox(10, "right");
            rc1 = new qx.ui.container.Composite(layout);
            rc1.setMargin(10, 10, 10, 10);
            w.add(rc1);

            btn = new qx.ui.form.Button("Cancel",
                "pf/image/cancel.png");
            btn.addListener("execute", function(ev) {
                    this.saveLoadWindow.close();
                }, this);
            rc1.add(btn);

            btn = new qx.ui.form.Button("OK",
                "pf/image/ok.png");
            btn.setEnabled(false);
            btn.addListener("execute", function(ev) {
                    var cfgname = this.saveLoadTextField.getValue(); 
                    if (!cfgname) {
                        this.msgWindow.error("Please enter a name!");
                    } else {
                        var type = w.getUserData("type");
                        if (type == "save") {
                            if (this.saveConfig(cfgname) == true) {
                                this.saveLoadWindow.close();
                                if (this.prefs.currentConfigName) {
                                    this.gui_configName.setLabel(this.prefs.currentConfigName);
                                }
                            } else {
                                this.msgWindow.error("Save failed!");
                            }
                        } else {
                            if (this.loadConfig(cfgname) == true) {
                                this.updatePlasmaParameters();
                                this.updateGUI();
                                if (this.prefs.saveFavsWithConfig) {
                                    this.rePopulateTree();
                                }
                                this.drawAll();
                                this.saveLoadWindow.close();
                            } else {
                                this.msgWindow.error("Load failed!");
                            }
                        }
                    }
                }, this);
            rc1.add(btn);

            e.setLiveUpdate(true);
            e.addListener("changeValue", function(ev) {
                    var name = this.getValue();
                    btn.setEnabled(null != name && name.length != 0);
                });
        },

        createPrefsDialog : function()
        {
            // "Preferences..." dialog
            var w = new pf.ui.DialogWindow("Preferences",
                "pf/image/preferences.png");
            w.setLayout(new qx.ui.layout.VBox(10));

            this.doc.add(w);
            this.prefsWindow = w;
            
            var fr, l, e;

            fr = new qx.ui.groupbox.GroupBox("General");
            fr.setLayout(new qx.ui.layout.VBox(10));
            w.add(fr);

            e = new qx.ui.form.CheckBox("Save favorites with configurations");
            e.setValue(this.prefs.saveFavsWithConfig);
            e.addListener("changeValue", function(ev) {
                this.prefs.saveFavsWithConfig = ev.getTarget().getValue();
                this.savePreferences();
            }, this);
            fr.add(e);
            
            fr = new qx.ui.groupbox.GroupBox("Default units");
            fr.setLayout(new qx.ui.layout.HBox(10));
            w.add(fr);
            
            var unit_cb_enabled = false;
            
            l = new qx.ui.basic.Label("Dimension:");
            e = new pf.ui.SelectBox;
            e.addItem("Length", "length");
            e.addItem("Frequency", "frequency");
            e.addItem("Velocity", "velocity");
            e.addItem("Energy", "energy");
            e.addItem("Mass density", "mass_density");
            e.addItem("Pressure", "pressure");
            e.addItem("Area", "area");
            e.addItem("Power density", "power_density");
            e.addItem("Power spectral density", "spectral_power_density");
            e.addItem("Electric field", "efield");
            e.addListener("changeSelection", function(ev) {
                    var dimension = ev.getTarget().getSelectedValue();
                    unit_cb_enabled = false;
                    this.gui_prefs_units.update(dimension,
                        this.prefs.units[dimension]);
                    unit_cb_enabled = true;
                }, this);
            fr.add(l);
            fr.add(e);
            this.gui_prefs_dim = e;

            l = new qx.ui.basic.Label("Units:");
            e = new pf.UnitSelector();
            e.addListener("changeSelection", function(ev) {
                    if (unit_cb_enabled) {
                        var dimension = this.gui_prefs_dim.getSelectedValue();
                        var units = ev.getTarget().getSelectedValue();
                        this.prefs.units[dimension] = units;
                        this.savePreferences();
                    }
                }, this);
            fr.add(l);
            fr.add(e);
            e.update("length", this.prefs.units["length"]);
            this.gui_prefs_units = e;
            
            unit_cb_enabled = true;

            fr = new qx.ui.groupbox.GroupBox("Interface");
            fr.setLayout(new qx.ui.layout.VBox(10));
            w.add(fr);

            e = new qx.ui.form.CheckBox("Load Wikipedia articles automatically");
            e.setValue(this.prefs.autoLoadWiki);
            e.addListener("changeValue", function(ev) {
                this.prefs.autoLoadWiki = ev.getTarget().getValue();
                this.savePreferences();
            }, this);
            fr.add(e);

            e = new qx.ui.form.CheckBox("Remember window dimensions on exit");
            e.setValue(this.prefs.rememberWindowSize);
            e.addListener("changeValue", function(ev) {
                this.prefs.rememberWindowSize = ev.getTarget().getValue();
                this.savePreferences();
            }, this);
            fr.add(e);

            e = new qx.ui.form.CheckBox("Warn on exit or restart");
            e.setValue(this.prefs.warnOnExit);
            e.addListener("changeValue", function(ev) {
                this.prefs.warnOnExit = ev.getTarget().getValue();
                this.savePreferences();
            }, this);
            fr.add(e);

            fr = new qx.ui.groupbox.GroupBox("Theme");
            fr.setLayout(new qx.ui.layout.VBox(10));
            w.add(fr);
            
            var btn1 = new qx.ui.form.RadioButton("Modern");
            btn1.setModel("modern");
            var btn2 = new qx.ui.form.RadioButton("Classic");
            btn2.setModel("classic");
            var btn3 = new qx.ui.form.RadioButton("Simple");
            btn3.setModel("simple");
            var btn4 = new qx.ui.form.RadioButton("Indigo");
            btn4.setModel("indigo");
            
            fr.add(btn1);
            fr.add(btn2);
            fr.add(btn3);
            fr.add(btn4);
            
            var rm = new qx.ui.form.RadioGroup(btn1, btn2, btn3, btn4);
            var sels;
            switch (this.prefs.themeName) {
            case "classic":
                sels = new Array(btn2);
                break;
            case "simple":
                sels = new Array(btn3);
                break;
            case "indigo":
                sels = new Array(btn4);
                break;
            default:
                sels = new Array(btn1);
                break;
            }
            rm.setSelection(sels);
            rm.addListener("changeSelection", function(ev) {
                    var btn = ev.getData()[0];
                    this.prefs.themeName = btn.getModel();
                    this.savePreferences();
                    
                    this.msgWindow.info("New theme will be applied after restart of the application");
                }, this);

        },

        applyTheme : function()
        {
            var theme;
            switch (this.prefs.themeName) {
            case "classic":
                theme = pf.theme.Classic;
                break;
            case "simple":
                theme = qx.theme.Simple;
                break;
            case "indigo":
                theme = qx.theme.Indigo;
                break;
            default:
                theme = pf.theme.Modern;
                break;
            }
            var thm = qx.theme.manager.Meta.getInstance();
            thm.setTheme(theme);
        },

        /**
         * TODOC
         *
         * @type member
         * @param e {Event} TODOC
         * @return {void}
         */
        main : function(e)
        {
            this.base(arguments);

            // Enable logging in debug variant
            if (qx.core.Environment.get("qx.debug")) {
                // support native logging capabilities, e.g. Firebug
                qx.log.appender.Native;
                // support additional cross-browser console. (Press F7)
                qx.log.appender.Console;
            }
            
            this.doc = this.getRoot();
            
            // Load prefs
            this.loadPreferences();
            
            // Apply theme
            this.applyTheme();
            
            if (this.prefs.rememberWindowSize && this.prefs.dims) {
                self.resizeTo(this.prefs.dims.width, this.prefs.dims.height);
            }

            this.plasma = new pf.Plasma();
            
            // Load config from the previous session
            if (this.prefs.currentConfigName) {
                this.loadConfig(this.prefs.currentConfigName);
            }
            
            if (this.updatePlasmaParameters() != true) {
                this.error("Error updating plasma parameters!");
            }
            
            // Favorites
            this.loadFavorites();
            
            this.colorMap = new Array("red", "blue", "green", "orange",
                "brown", "olive", "teal", "magenta", "gray", "black");
            this.ncolor = 0;

            // Top-level container
            var layout = new qx.ui.layout.VBox;
            this.bl_top = new qx.ui.container.Composite(layout);

            this.doc.add(this.bl_top, {width :"100%", height: "100%"});

            // The menubar
            this.menubar = new qx.ui.menubar.MenuBar;
            this.bl_top.add(this.menubar);
            
            // The menu items
            this.buildMenu();
            
            this.tabview = new qx.ui.tabview.TabView;
            this.tabview.setContentPadding(6);
            
            this.bl_top.add(this.tabview, {flex: 1});
            // The "Parameters" tab
            this.renderParametersTab();
            
            // The "Explorer" tab
            this.renderExplorerTab();
            
            // The "Compare" tab
            this.renderCompareTab();
            this.updateFavoritesListView();
            
            // The "Plot" tab
            this.renderPlotTab();
            this.updateLegendListView();
            
            // "Preferences" dialog
            this.createPrefsDialog();

            // "Save as" dialog
            this.createSaveLoadDialog();

            // "About..." dialog
            var w = new pf.ui.DialogWindow("About Plasma Formulary",
                "pf/image/about.png");
            w.setLayout(new qx.ui.layout.VBox(10));

            var pf_version = qx.core.Environment.get("pf.version");
            var qx_version = qx.core.Environment.get("qx.version");
            var str = 'Plasma Formulary Interactive '            +
                      pf_version + '.<br/>'                      +
                      '<p>Created by Evgeny Stambulchik.</p>'    +
                      'GUI built with the qooxdoo-' + qx_version +
                      ' toolkit.<br/>'                           + 
                      'Using Walter Zorn jsGraphics for drawing.';

            var a = new qx.ui.basic.Atom(str);
            a.setRich(true);
            w.add(a);

            this.doc.add(w);
            this.aboutWindow = w;
            
            this.msgWindow = new pf.ui.MessageWindow();
            this.doc.add(this.msgWindow);
            this.confirmDialog = new pf.ui.ConfirmDialog();
            this.doc.add(this.confirmDialog);
            this.promptDialog = new pf.ui.PromptDialog();
            this.doc.add(this.promptDialog);
            
            // Handle resize events
            this.doc.addListener("resize", function(e) {
                if (this.prefs.rememberWindowSize) {
                    this.prefs.dims = this.doc.getInnerSize();
                    this.savePreferences();
                }
                this.drawAll();
            }, this);
        },
    

        /**
         * TODOC
         *
         * @type member
         * @param e {Event} TODOC
         * @return {void}
         */
        close : function(e)
        {
            this.base(arguments);
            
            // Prompt user
            if (this.prefs.warnOnExit && !this.intendedExit) {
                return "This will end your Plasma Formulary session.";
            }
        }
    }
});
